#include "enemy.h"
#include "badguy.h"
#include "projectile.h"
#include "player.h"
#include "map1.h"
#include "hero.h"

// Definicion
TEnemy enemy;

/****************************************INICIALIZAR ENEMIGO****************************************/

//Animaciones
#define EPAUSE 4
#define EFRAMES_MOVING 8
#define EFRAMES_JUMPING 1

//Array de sprites
#define ENEMY_FRAMES 2

const TSprite2 g_frames2[ENEMY_FRAMES] = {
	{ RIGHT, g_badguy_0 } , { RIGHT, g_badguy_1 }
};

// Inicializar enemigo
void enemy_initialize(u8 x, u8 y, i8 dir){
	enemy.x=enemy.px=enemy.ppx=x;
	enemy.y=enemy.py=enemy.ppy=y;
	enemy.y = (enemy.y & 0b11111100) + 2;
	enemy.vy = 0;
	enemy.spawn=40;
	enemy.nframe=0;
	enemy.facing=dir;
	if(enemy.facing==RIGHT)
		enemy.sprite=&g_frames2[0];
	else
		enemy.sprite=&g_frames2[1];
	enemy.stamina=100;
	enemy.state=ST_STILL;
	enemy.life=1;
	enemy.moving=2;
	enemy.pShoot=NO;
}

//Tabla de transparencias
cpctm_declareMaskTable(g_transTable);
extern u8 *g_backBuffer;
extern u8 *g_screenMem;

//Dibujar y borrar sprite
void enemy_draw(){
	u8* pvmem = cpct_getScreenPtr(g_backBuffer, enemy.x, enemy.y);
	cpct_drawSpriteMaskedAlignedTable (enemy.sprite->img, pvmem, G_BADGUY_0_W, G_BADGUY_0_H, g_transTable);
}

void enemy_delete(){
	u8* pvmem = cpct_getScreenPtr(g_backBuffer, 0, ORIGEN_MAPA_Y);
	u8 w = 5 + (enemy.ppx & 1);
	u8 h = 6 + (enemy.ppy & 3 ? 1 : 0);
	cpct_etm_drawTileBox2x4 (enemy.ppx / 2, (enemy.ppy - ORIGEN_MAPA_Y)/4, w, h, 40, pvmem, mapa);
}

void enemy_delete2(){
	u8* pvmem = cpct_getScreenPtr(g_screenMem, 0, ORIGEN_MAPA_Y);
	u8 w = 5 + (enemy.ppx & 1);
	u8 h = 6 + (enemy.ppy & 3 ? 1 : 0);
	cpct_etm_drawTileBox2x4 (enemy.ppx / 2, (enemy.ppy - ORIGEN_MAPA_Y)/4, w, h, 40, pvmem, mapa);
}

void enemy_drawUpdate(){
	enemy.ppx = enemy.px;
	enemy.ppy = enemy.py;
	enemy.px = enemy.x;
	enemy.py = enemy.y;
	--enemy.moving;
}

void enemy_redraw(){
	enemy_delete();
	enemy_draw();
	enemy_drawUpdate();
}



//////////////////////////////

/****************************************ESTADOS Y ANIMACIONES****************************************/




// IA
void enemy_IA(){

	// Acciones dependiendo de si ve o no al jugador
	/*if(enemy.see==NO){
		enemy_move();
		enemy.state=ST_MOVING;
		enemy.moving=2;
		enemy_setFrame(anim_moving2);
		enemy_animateMoving(enemy.facing);
		if(enemy.x>player.x){
			if((enemy.x - player.x) <=20 && enemy.facing==LEFT)
				enemy.see=YES;
		}else if(player.x>enemy.x){
			if((player.x - enemy.x) <=20 && enemy.facing==RIGHT)
				enemy.see=YES;
		}
	}if(enemy.see==YES){
		enemy_stalk();
		enemy.state=ST_MOVING;
		enemy.moving=2;
		enemy_setFrame(anim_moving2);
		enemy_animateMoving(enemy.facing);
		if((enemy.x - player.x) >20 || (enemy.x - player.x) <-20)
			enemy.see=NO;
	}
	enemy_flipSprite();*/
	if(enemy.life==1){
		if(enemy.x>player.x){
			if((enemy.x - player.x) <=60 && enemy.y >= player.y && enemy.y <= player.y + G_HERO_00_H && enemy.facing==LEFT)
				enemy_shoot();
		}else if(player.x>enemy.x){
			if((player.x - enemy.x) <=60 && enemy.y >= player.y && enemy.y <= player.y + G_HERO_00_H && enemy.facing==RIGHT)
				enemy_shoot();
		}
	}
}

// Dispara
void enemy_shoot(){
	if(enemy.pShoot==NO){
		projectile_initialize(1);
		enemy.pShoot=YES;
	}
}
