#ifndef _ENEMY_H_
#define _ENEMY_H_

#include <cpctelera.h>
#include "mapa.h"

// Rellenar los enemigos utilizando como referencia player.h
//Sprite y direccion a la que mira
typedef struct {
	i8 dir;
	u8* img;
}TSprite2;

//Variables del enemigo
typedef struct{
	u8 x, y;
	u8 px, py;
	u8 ppx, ppy;
	i8 vy;
	u8 spawn; // Posicion sobre la que se mueve
	TSprite2* sprite;
	i8 facing;
	u8 stamina;
	u8 state;
	u8 nframe;
	u8 life;
	u8 moving;
	u8 pShoot;
}TEnemy;

extern TEnemy enemy;

//Para los estados
#define YES 1
#define NO 0

// Estados del enemigo
#define ST_STILL 0
#define ST_MOVING 1
#define ST_JUMING 2
#define ST_FALLING 3

//Aceleracion de caida
#define GRAVITY 1

//Direccion a la que mira
#define LEFT -1
#define RIGHT 1

//Posicion del mapa
/*#define ORIGEN_MAPA_Y   68
#define ORIGEN_MAPA     cpctm_screenPtr(CPCT_VMEM_START, 0, ORIGEN_MAPA_Y)*/

// Inicializar enemigo
void enemy_initialize(u8 x, u8 x, i8 dir);

//Dibujar y borrar sprite
void enemy_draw();
void enemy_delete();
void enemy_delete2();
void enemy_drawUpdate();
void enemy_redraw();

//Animaciones

void enemy_setFrame(TSprite2 **anim);
void enemy_animateMoving(i8 facing);

//u8* obtenerTilePtr(u8 x, u8 y);
void enemy_setOnGround();
u8 enemy_onGround();

void enemy_flipSprite();

// IA
void enemy_IA();

// Acciones
void enemy_stalk();
void enemy_shoot();
void enemy_move();
void enemy_return();
void enemy_jumping();
void enemy_jump();
void enemy_fall();

// Terminar de completar con metodos propios de estos


#endif