//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of CPCtelera: An Amstrad CPC Game Engine
//  Copyright (C) 2015 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

#include <stdio.h>
#include <cpctelera.h>
#include "player.h"
#include "tiles.h"
#include "projectile.h"
#include "enemy.h"
#include "fondo.h"
#include "hero.h"
#include "badguy.h"
#include "song.h"


cpctm_createTransparentMaskTable(g_transTable, 0x0100, M0, 0);

void playmusic() {
   __asm 
      exx
      .db #0x08
      push af
      push bc
      push de
      push hl
      call _cpct_akp_musicPlay
      pop hl
      pop de
      pop bc
      pop af
      .db #0x08
      exx
   __endasm;
}

void interrupcion() {
   static u8 kk;

   if (++kk == 5) {
      playmusic();
      cpct_scanKeyboard_if();
      kk = 0;
   }
   
}

void inicializar() {
   cpct_disableFirmware();
   cpct_setVideoMode(0);
   cpct_akp_musicInit(g_mysong);
   cpct_setInterruptHandler(interrupcion);
   cpct_memset((u8*)0x8000, 0, 0x4000);
   cpct_setPalette(g_palette, 16);
   cpct_setBorder(HW_BLACK);
   cpct_etm_setTileset2x4(g_tileset);

   /*inicializarMapa();
   player_initialize();
   enemy_initialize(157, 0);*/


   //cpct_akp_musicInit(G_song);
   //cpct_setInterruptHandler(interrupcion);
}

extern u8 *g_backBuffer;
extern u8 *g_screenMem;

void dummy_initializer(){
   __asm
      _g_backBuffer::   .dw 0x8000
      _g_screenMem::    .dw 0XC000

   __endasm;
}

void switchBuffers(){
   u8* aux = g_backBuffer;
   g_backBuffer = g_screenMem;
   g_screenMem = aux;

   cpct_setVideoMemoryPage(((u16)g_screenMem) >> 10);
}

void main(void) {
   u8 entrarMapa0;
   u8 entrarMapa1;
   u8 entrarMapa2;
   u8 entrarMapa3;
   u8 entrarMapa4;
   u8 entrarMapa5;
   u8 pantalla; //menu
   u8* pscr;
   u8* tscr;   // Pointer to the screen place where to show messages
   u8  str[6]; // String array to draw numbers on screen
   u16 score;
   u8* message;
   u8* title;
   cpct_setStackLocation((void*)0x8000);
   entrarMapa0=0;
   entrarMapa1=0;
   entrarMapa2=0;
   entrarMapa3=0;
   entrarMapa4=0;
   entrarMapa5=0;
   pantalla = 0; //menu
   score = 0;
   //u8* pscr;
   /*u8* message;
   u8* title;*/

   inicializar();

   // Loop forever
   while (1) {

      if(pantalla == 0){
         //cpct_drawSolidBox (cpctm_screenPtr(CPCT_VMEM_START,  0, 0), g_palette[0], 40,  200);
         //cpct_drawSolidBox (cpctm_screenPtr(CPCT_VMEM_START,  40, 0), g_palette[0], 40,  200);
         //cpct_drawSprite(g_fondo, cpctm_screenPtr(CPCT_VMEM_START,  30, 90), G_FONDO_W, G_FONDO_H);
         //pscr = cpct_getScreenPtr(g_backBuffer, 0,  0);
         cpct_drawSprite(g_fondo_0, cpctm_screenPtr(g_screenMem, 20, 80), G_FONDO_0_W, G_FONDO_0_W);
         cpct_drawSprite(g_fondo_1, cpctm_screenPtr(g_screenMem, 40, 80), G_FONDO_0_W, G_FONDO_0_H);
         cpct_drawSprite(g_fondo_2, cpctm_screenPtr(g_screenMem, 20, 102), G_FONDO_0_W, G_FONDO_0_W);
         cpct_drawSprite(g_fondo_3, cpctm_screenPtr(g_screenMem, 40, 102), G_FONDO_0_W, G_FONDO_0_H);
         pscr = cpct_getScreenPtr(g_screenMem, 25,  130);   
         cpct_drawStringM0("SIDEGUN", pscr, 4, 0);
         pscr = cpct_getScreenPtr(g_screenMem, 15,  150);   
         cpct_drawStringM0("PRESS SPACEBAR", pscr, 14, 0);
      }
      cpct_scanKeyboard_f();
      if(pantalla == 0 && cpct_isKeyPressed(Key_Space)){
         inicializarMapa();
         player_initialize();
         enemy_initialize(64, ORIGEN_MAPA_Y + 48, -1);

         pscr = cpct_getScreenPtr(g_backBuffer, 10,  16);  
         cpct_drawStringM0("SCORE:", pscr, 14, 0);
         pscr = cpct_getScreenPtr(g_screenMem, 10,  16); 
         cpct_drawStringM0("SCORE:", pscr, 14, 0);
           // Draw the score got in this game
         tscr = cpct_getScreenPtr(g_backBuffer, 30, 16);
         sprintf(str, "%5u", score);
         cpct_drawStringM0(str, tscr, 14, 0);
         tscr = cpct_getScreenPtr(g_screenMem, 30, 16);
         sprintf(str, "%5u", score);
         cpct_drawStringM0(str, tscr, 14, 0);
         pantalla = 1;
      
      }
      if(pantalla == 1){

         //DIBUJAR AQUI LA PARTE DEL HUD O LO Q SEA


         /////
         
        
         

         player_checkState();
      //checkKeyboard();
      
      //projectile
      //cpct_scanKeyboard_f();
      /*if(cpct_isKeyPressed(Key_Space)){
         player_shoot();
      }*/
      if(player.pShoot==YES){
         projectile_redraw(0);
      }
      if((projectile.x>=ANCHO-3 && projectile.x < 200) || projectile.x<=0){
         projectile_delete2(0);
         projectile.x = 250;
         player.pShoot=NO;
      }
      if((projectile.x >= enemy.x && projectile.x <= enemy.x + G_BADGUY_0_W &&
         projectile.y >= enemy.y && projectile.y <= enemy.y + G_BADGUY_0_H)
         ||
         (projectile.x + 5 >= enemy.x && projectile.x + 5 <= enemy.x + G_BADGUY_0_W &&
         projectile.y + 5 >= enemy.y && projectile.y + 5 <= enemy.y + G_BADGUY_0_H)){
         enemy.life=0;
         enemy_delete();
         enemy_delete2();
         projectile_delete2(0);
         projectile_delete2(1);
         player.pShoot=NO;
         projectile.x = 250;
         eProjectile.x = 250;
         enemy.x = 200;
         score+=10;

         tscr = cpct_getScreenPtr(g_backBuffer, 30, 16);
         sprintf(str, "%5u", score);
         cpct_drawStringM0(str, tscr, 14, 0);
         tscr = cpct_getScreenPtr(g_screenMem, 30, 16);
         sprintf(str, "%5u", score);
         cpct_drawStringM0(str, tscr, 14, 0);
      }
      if(enemy.pShoot==YES && enemy.life==1){
         projectile_redraw(1);
      }
      if((eProjectile.x>=ANCHO-3 && eProjectile.x < 200) || eProjectile.x<=0){
         projectile_delete2(1);
         enemy.pShoot=NO;
         eProjectile.x = 250;
      }
      if(player.moving){
         player_selectSprite();
         player_redraw();
      }
      if((eProjectile.x >= player.x && eProjectile.x <= player.x + G_HERO_00_W &&
         eProjectile.y >= player.y && eProjectile.y <= player.y + G_HERO_00_H)
         ||
         (eProjectile.x + 5 >= player.x && eProjectile.x + 5 <= player.x + G_HERO_00_W &&
         eProjectile.y + 5 >= player.y && eProjectile.y + 5 <= player.y + G_HERO_00_H)){
         // Game Over y Pantalla de inicio
         enemy.life=0;
         enemy_delete();
         projectile_delete2(1);
         eProjectile.x = 250;
         enemy.pShoot=NO;
         entrarMapa0=0;
         entrarMapa1=0;
         entrarMapa2=0;
         entrarMapa3=0;
         entrarMapa4=0;
         entrarMapa5=0;
         pantalla=0;
         cpct_memset((u8*)0x8000, 0, 0x8000);
      }
      if(enemy.moving && enemy.life==1){
         enemy_redraw();
      }
      if(num_mapa==0 && entrarMapa0==0){
         enemy_initialize(64, ORIGEN_MAPA_Y + 48, -1);
         entrarMapa0=1;
      }
      if(num_mapa==1 && entrarMapa1==0){
         enemy_initialize(64, ORIGEN_MAPA_Y + 8, -1);
         entrarMapa1=1;
      }
      if(num_mapa==2 && entrarMapa2==0){
         enemy_initialize(20, ORIGEN_MAPA_Y + 128, 1);
         entrarMapa2=1;
      }
      if(num_mapa==3 && entrarMapa3==0){
         enemy_initialize(64, ORIGEN_MAPA_Y + 76, -1);
         entrarMapa3=1;
      }
      if(num_mapa==4 && entrarMapa4==0){
         enemy_initialize(36, ORIGEN_MAPA_Y + 12, -1);
         entrarMapa4=1;
      }
      if(num_mapa==5 && entrarMapa5==0){
         enemy_initialize(10, ORIGEN_MAPA_Y + 60, 1);
         entrarMapa5=1;
      }
      if(num_mapa==6){
         entrarMapa0=0;
         entrarMapa1=0;
         entrarMapa2=0;
         entrarMapa3=0;
         entrarMapa4=0;
         entrarMapa5=0;
      }
      
      enemy_IA();

      cpct_waitVSYNC();
      switchBuffers();
      }
      
   }

   //while (1);
   /* Esta parte va en player.c? */
   /*cpct_scanKeyboard_f();
      if(cpct_isKeyPressed(Key_Space)){
         proyectiles=+crearProyectil();
         //disparado=1; // Esto actua como un bool.
                        // Para evitar que el proyectil cambie de direccion una vez en el aire
      }*/
   /*****************************/
      /*if(nProyectiles>0){
         //proyectiles=+
         redibujarProyectil();
         if(proyectil.x==0 || proyectil.x==ANCHO-5){
            nProyectiles--;
            //disparado=0; // 
            borrarProyectil();
         }

      }*/
}
