//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of CPCtelera: An Amstrad CPC Game Engine
//  Copyright (C) 2015 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

#include "player.h"
#include "tiles.h"
#include "map1.h"
#include "map2.h"
#include "map3.h"
#include "map4.h"
#include "map5.h"
#include "map6.h"
#include "map7.h"
#include "hero.h"

u8* mapa;
u8  num_mapa;
u8* const mapas[NUM_MAPAS] = { g_map1, g_map2 , g_map3 , g_map4, g_map5, g_map6, g_map7};

extern u8 *g_backBuffer;
extern u8 *g_screenMem;

void dibujarMapa() {
   u8* pvmem = cpct_getScreenPtr(g_backBuffer, 0, ORIGEN_MAPA_Y);
   cpct_etm_drawTilemap2x4(g_map1_W, g_map1_H, pvmem, mapa);
   pvmem = cpct_getScreenPtr(g_screenMem, 0, ORIGEN_MAPA_Y);
   cpct_etm_drawTilemap2x4(g_map1_W, g_map1_H, pvmem, mapa);
}

void inicializarMapa() {
   
   cpct_etm_setTileset2x4(g_tileset);
   mapa = g_map1;
   num_mapa = 0;

   dibujarMapa();
   
}

void avanzarMapa() {
   if (num_mapa < NUM_MAPAS-1) {
      mapa = mapas[++num_mapa];
      player.y = player.py = player.ppy = 175;
      player.moving = 2;
      dibujarMapa();
   }else{
      num_mapa = 0;
      mapa = mapas[num_mapa];
      player.y = player.py = player.ppy = 175;
      player.moving = 2;
      dibujarMapa();
   }

}

void retrocederMapa() {
   if (num_mapa > 0) {
      mapa = mapas[--num_mapa];
      //num_mapa = num_mapa-1;
		//mapa = g_map1;
      player.y = player.py = player.ppy = ORIGEN_MAPA_Y + 5;
      player.moving = 2;
      dibujarMapa();
   }
}