#ifndef _PLAYER_H_
#define _PLAYER_H_

#include <cpctelera.h>
#include "mapa.h"

//Sprite y direccion a la que mira
typedef struct {
	i8 dir;
	u8* img;
} TSprite;

//Variables del personaje
typedef struct {
	u8 x, y;
	u8 px, py;
	u8 ppx, ppy;
	i8 vy;
	i8 facing;
	TSprite* sprite;
	u8 state;
	u8 nframe;
	u8 moving;
	u8 pShoot;
	u8 djumping;
} TPlayer;

//Declaracion para usar en cualquier sitio
extern TPlayer player;

//Para los estados
#define YES 1
#define NO 0

//Aceleracion de caida
#define GRAVITY 1

//Direccion a la que mira
#define LEFT -1
#define RIGHT 1

//Estados
#define ST_STILL 0
#define ST_MOVING 1
#define ST_JUMPING 2
#define ST_FALLING 3
#define ST_DJUMPING 4
#define ST_DFALLING 5

//Posicion del mapa
/*#define ORIGEN_MAPA_Y   40
#define ORIGEN_MAPA     cpctm_screenPtr(CPCT_VMEM_START, 0, ORIGEN_MAPA_Y)*/

//Inicializar personaje
void player_initialize();

//Dibujar y borrar sprite
void player_draw();
void player_delete();
void player_drawUpdate();
void player_redraw();

//Estados y animaciones
void player_checkState();
void player_still();
void player_moving();
void player_jumping();
void player_falling();
void player_djumping();
void player_dfalling();
void player_newState(u8 state);
u8 player_checkKeys(const cpct_keyID* k, u8 numk);
void player_checkDJumping();
void player_setFrame(TSprite **anim);
void player_animateMoving(i8 facing);
void player_animateDFalling(/*i8 facing*/);
void player_selectSprite();
u8* obtenerTilePtr(u8 x, u8 y);
void player_setOnGround();
u8 player_onGround();
u8 player_onCeiling();
u8 player_onWallLeft();
u8 player_onWallRight();

//Movimiento
void player_moveLeft();
void player_moveRight();
void player_jump();
void player_fall();

//Disparo
void player_shoot();

#endif