#include "projectile.h"
#include "player.h"
#include "enemy.h"
#include "mapa.h"

// Definicion
TProjectile projectile;
TProjectile eProjectile;

extern u8 *g_backBuffer;
extern u8 *g_screenMem;


void projectile_initialize(u8 number){
	if(number==0){
      if(player.facing==1){
         projectile.x=player.x+10;
         projectile.px=projectile.x;
         projectile.ppx =projectile.x;
         projectile.facing=1;
         projectile.moving=2;
      }
      else if(player.facing==-1){
         projectile.x=player.px-5;
         projectile.px=projectile.x;
         projectile.ppx =projectile.x;
         projectile.facing=-1;
         projectile.moving=2;
      }
      projectile.y=player.py+7;
   }
   else if(number==1){
      if(enemy.facing==1){
         eProjectile.x=enemy.x+10;
         eProjectile.px=eProjectile.x;
         eProjectile.ppx =eProjectile.x;
         eProjectile.facing=1;      
         eProjectile.moving=2;
      }else if(enemy.facing==-1){
         eProjectile.x=enemy.px-7;
         eProjectile.px=eProjectile.x;
         eProjectile.ppx =eProjectile.x;
         eProjectile.facing=-1;
         eProjectile.moving=2;
      }
      eProjectile.y=enemy.py+7;
   }
}

void projectile_draw(u8 number){
   if(number==0){
      u8* pvmen = cpct_getScreenPtr(g_backBuffer, projectile.x, projectile.y);
      cpct_drawSolidBox(pvmen, FW_RED, 3, 3);
   }
   else if(number==1){
      u8* pvmen = cpct_getScreenPtr(g_backBuffer, eProjectile.x, eProjectile.y);
      //cpct_drawSprite(p.sprite, pvmen, ---W projectile---, ---H projectile---);
      cpct_drawSolidBox(pvmen, FW_RED, 3, 3);
   }
}

void projectile_delete(u8 number){
   if(number==0){
      u8* pvmem = cpct_getScreenPtr(g_backBuffer, 0, ORIGEN_MAPA_Y);
      u8 w = 2 + (projectile.ppx & 1); // Los numeros 3 y 2 se deben adaptar
      u8 h = 1 + (projectile.y & 3 ? 1 : 0);
      cpct_etm_drawTileBox2x4(projectile.ppx / 2, (projectile.y-ORIGEN_MAPA_Y) / 4, w, h, 40, pvmem, mapa);
   }
   else if(number==1){
      u8* pvmem = cpct_getScreenPtr(g_backBuffer, 0, ORIGEN_MAPA_Y);
      u8 w = 2 + (eProjectile.ppx & 1); // Los numeros 3 y 2 se deben adaptar
      u8 h = 1 + (eProjectile.y & 3 ? 1 : 0);
      cpct_etm_drawTileBox2x4(eProjectile.ppx / 2, (eProjectile.y-ORIGEN_MAPA_Y) / 4, w, h, 40, pvmem, mapa);
   }
}

void projectile_delete2(u8 number){
   if(number==0){
      u8* pvmem = cpct_getScreenPtr(g_backBuffer, 0, ORIGEN_MAPA_Y);
      u8 w = 2 + (projectile.ppx & 1); // Los numeros 3 y 2 se deben adaptar
      u8 h = 1 + (projectile.y & 3 ? 1 : 0);
      cpct_etm_drawTileBox2x4(projectile.ppx / 2, (projectile.y-ORIGEN_MAPA_Y) / 4, w, h, 40, pvmem, mapa);
      pvmem = cpct_getScreenPtr(g_screenMem, 0, ORIGEN_MAPA_Y);
      cpct_etm_drawTileBox2x4(projectile.ppx / 2, (projectile.y-ORIGEN_MAPA_Y) / 4, w, h, 40, pvmem, mapa);
   }
   else if(number==1){
      u8* pvmem = cpct_getScreenPtr(g_backBuffer, 0, ORIGEN_MAPA_Y);
      u8 w = 2 + (eProjectile.ppx & 1); // Los numeros 3 y 2 se deben adaptar
      u8 h = 1 + (eProjectile.y & 3 ? 1 : 0);
      cpct_etm_drawTileBox2x4(eProjectile.ppx / 2, (eProjectile.y-ORIGEN_MAPA_Y) / 4, w, h, 40, pvmem, mapa);
      pvmem = cpct_getScreenPtr(g_screenMem, 0, ORIGEN_MAPA_Y);
      cpct_etm_drawTileBox2x4(eProjectile.ppx / 2, (eProjectile.y-ORIGEN_MAPA_Y) / 4, w, h, 40, pvmem, mapa);
   }
}

void projectile_move(u8 number){
   if(number==0){
      if(projectile.facing==1 && projectile.x<ANCHO-3){
         projectile.px=projectile.x;
         projectile.x++;
         projectile.moving=2;
      }
      else if(projectile.facing==-1 && projectile.x>0){
         projectile.px=projectile.x;
         projectile.x--;
         projectile.moving=2;
      }
   }
   else if(number==1){
      if(eProjectile.facing==1 && eProjectile.x<ANCHO-3){
         eProjectile.px=eProjectile.x;
         eProjectile.x++;
         eProjectile.moving=2;
      }
      else if(eProjectile.facing==-1 && eProjectile.x>0){
         eProjectile.px=eProjectile.x;
         eProjectile.x--;
         eProjectile.moving=2;
      }  
   }
}

void projectile_drawUpdate(u8 number){
   if(number==0){
      projectile.ppx = projectile.px;
      projectile.px = projectile.x;
      --projectile.moving;
   }else{
      eProjectile.ppx = eProjectile.px;
      eProjectile.px = eProjectile.x;
      --eProjectile.moving;
   }
}

void projectile_redraw(u8 number){
	projectile_delete(number);
	projectile_move(number);
	projectile_draw(number);
   projectile_drawUpdate(number);
}